-- name: [CS] PRINCESS PEACH
-- description: Princess Peach, pretty obscure Mario character, i know \n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!



local E_MODEL_PEACH = smlua_model_util_get_id("peach_player_geo")

local TEX_PEACH = get_texture_info("peach_player_icon")

local TEXT_MOD_NAME = "[CS] PRINCESS PEACH"

local VOICETABLE_PEACH = {
[CHAR_SOUND_ATTACKED] = 'attacked.ogg',
[CHAR_SOUND_COUGHING1] = 'coughing1.ogg',
[CHAR_SOUND_COUGHING2] = 'coughing2.ogg',
[CHAR_SOUND_COUGHING3] = 'coughing3.ogg',
[CHAR_SOUND_DOH] = 'doh.ogg',
[CHAR_SOUND_DROWNING] = 'drowning.ogg',
[CHAR_SOUND_DYING] = 'dying.ogg',
[CHAR_SOUND_EEUH] = 'euuh.ogg',
[CHAR_SOUND_GROUND_POUND_WAH] = 'ground_pound_wah.ogg',
[CHAR_SOUND_HAHA] = 'haha.ogg',
[CHAR_SOUND_HAHA_2] = 'haha.ogg',
[CHAR_SOUND_HERE_WE_GO] = 'herewego.ogg',
[CHAR_SOUND_HOOHOO] = 'hoohoo.ogg',
[CHAR_SOUND_HRMM] = 'hrmm.ogg',
[CHAR_SOUND_IMA_TIRED] = 'imatired.ogg',
[CHAR_SOUND_MAMA_MIA] = 'mamamia.ogg',
[CHAR_SOUND_LETS_A_GO] = 'letsago.ogg',
[CHAR_SOUND_ON_FIRE] = 'on_fire.ogg',
[CHAR_SOUND_OOOF] = 'ooof.ogg',
[CHAR_SOUND_OOOF2] = 'ooof2.ogg',
[CHAR_SOUND_PANTING] = 'panting.ogg',
[CHAR_SOUND_PANTING_COLD] = 'panting_cold.ogg',
[CHAR_SOUND_PUNCH_HOO] = 'punch_hoo.ogg',
[CHAR_SOUND_PUNCH_WAH] = 'punch_wah.ogg',
[CHAR_SOUND_PUNCH_YAH] = 'punch_yah.ogg',
[CHAR_SOUND_SO_LONGA_BOWSER] = 'solonga_bowser.ogg',
[CHAR_SOUND_SNORING1] = 'snoring1.ogg',
[CHAR_SOUND_SNORING2] = 'snoring2.ogg',
[CHAR_SOUND_SNORING3] = {'snoring2.ogg', 'snoring1.ogg', 'snoring3.ogg'},
[CHAR_SOUND_TWIRL_BOUNCE] = 'twirl_bounce.ogg',
[CHAR_SOUND_UH] = 'uh.ogg',
[CHAR_SOUND_UH2] = 'uh2.ogg',
[CHAR_SOUND_UH2_2] = 'uh2_2.ogg',
[CHAR_SOUND_WAAAOOOW] = 'waaaooow.ogg',
[CHAR_SOUND_WAH2] = 'ground_pound_wah.ogg',
[CHAR_SOUND_WHOA] = 'whoa.ogg',
[CHAR_SOUND_YAHOO] = 'yahoo.ogg',
[CHAR_SOUND_YAWNING] = 'yawning.ogg',
[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'yahoo.ogg', 'yahoo1.ogg', 'yahoo2.ogg', 'yahoo3.ogg', 'yahoo4.ogg', 'yahoo5.ogg' },
[CHAR_SOUND_YAH_WAH_HOO] = { 'yah_wah_hoo1.ogg', 'yah_wah_hoo2.ogg', 'yah_wha_hoo3.ogg'},
[CHAR_SOUND_HELLO] = 'float.ogg',
}

local peachfloat = true
ACT_DRESSFLOAT = allocate_mario_action(ACT_GROUP_AIRBORNE |  ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION | ACT_FLAG_MOVING)

local capPEACH = {
    normal = smlua_model_util_get_id("peachs_cap_geo"),
    wing = smlua_model_util_get_id("peachs_wing_cap_geo"),
    metal = smlua_model_util_get_id("peachs_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("peachs_metal_wing_cap_geo")
}

local PALETTE_PEACH = {
    [SHIRT] = "F8C0B8",
    [SHOES] = "ffffff",
    [HAIR] = "FFD302",
    [CAP] = "ffffff",
    [PANTS] = "EFCA11",
    [GLOVES] = "ffffff",
    [SKIN] = "F8E0A0",
}

_G.charSelect.character_add_caps(E_MODEL_PEACH, capPEACH)

if _G.charSelectExists then
    CT_PEACH = _G.charSelect.character_add("Princess Peach", "The ruler of the Mushroom Kingdom, always ready to help Mario in his adventures and save her kingdom from the evil clutches of King Bowser! Voiced by SuperKirbyLover", "Melzinoff & SuperKirbyLover", {r = 239, g = 128, b = 177}, E_MODEL_PEACH, CT_MARIO, TEX_PEACH)

    CT_PEACH_NOFLOAT = _G.charSelect.character_add("Princess Peach", "The ruler of the Mushroom Kingdom, always ready to help Mario in his adventures and save her kingdom from the evil clutches of King Bowser! Voiced by SuperKirbyLover !!! This one does not have the float move !!!", "Melzinoff & SuperKirbyLover", {r = 239, g = 128, b = 177}, E_MODEL_PEACH, CT_MARIO, TEX_PEACH)

    _G.charSelect.character_add_palette_preset(E_MODEL_PEACH, PALETTE_PEACH)
    -- the following must be hooked for each character added
    _G.charSelect.character_add_voice(E_MODEL_PEACH, VOICETABLE_PEACH)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_PEACH then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_PEACH then return _G.charSelect.voice.snore(m) end
    end)



    -- table to associate animation IDs with our registered lua animation names
    local peachplayerAnims = {
        [CHAR_ANIM_RUNNING] = 'peach_running',
        [CHAR_ANIM_IDLE_HEAD_CENTER] = 'peach_idle_head_center',
        [CHAR_ANIM_IDLE_HEAD_LEFT] = 'peach_idle_head_left',
        [CHAR_ANIM_IDLE_HEAD_RIGHT] = 'peach_idle_head_right',
        [CHAR_ANIM_BACKWARD_KB] = 'peach_backward_kb',
        [CHAR_ANIM_FIRST_PERSON] = 'peach_first_person',
        [CHAR_ANIM_FLUTTERKICK] = 'peach_flutterkick',
        [CHAR_ANIM_FLUTTERKICK_WITH_OBJ] = 'peach_flutterkick_with_obj',
        [CHAR_ANIM_FORWARD_KB] = 'peach_forward_kb',
        [CHAR_ANIM_GROUND_BONK] = 'peach_ground_bonk',
        [CHAR_ANIM_GROUND_KICK] = 'peach_ground_kick',
        [CHAR_ANIM_GROUND_THROW] = 'peach_ground_throw',
        [CHAR_ANIM_HEAVY_THROW] = 'peach_heavy_throw',
        [CHAR_ANIM_MISSING_CAP] = 'peach_missing_cap',
        [CHAR_ANIM_PULL_DOOR_WALK_IN] = 'peach_pull_door_walk_in',
        [CHAR_ANIM_FIRST_PERSON] = 'peach_first_person',
        [CHAR_ANIM_RELEASE_BOWSER] = 'peach_release_bowser',
        [CHAR_ANIM_RETURN_FROM_STAR_DANCE] = 'peach_return_from_star_dance',
        [CHAR_ANIM_RETURN_STAR_APPROACH_DOOR] = 'peach_return_star_approach_door',
        [CHAR_ANIM_SLIDEFLIP_LAND] = 'peach_sideflip_land',
        [CHAR_ANIM_SLEEP_IDLE] = 'peach_sleep_idle',
        [CHAR_ANIM_START_SLEEP_SITTING] = 'peach_sleep_sitting',
        [CHAR_ANIM_SOFT_BACK_KB] = 'peach_soft_back_kb',
        [CHAR_ANIM_SOFT_FRONT_KB] = 'peach_soft_front_kb',
        [CHAR_ANIM_STAR_DANCE] = 'peach_star_dance',
        [CHAR_ANIM_START_CROUCHING] = 'peach_start_crouch',
        [CHAR_ANIM_STOP_CROUCHING] = 'peach_stop_crouch',
        [CHAR_ANIM_START_SLEEP_IDLE] = 'peach_start_sleep',
        [CHAR_ANIM_STOP_SLIDE] = 'peach_stop_slide',
        [CHAR_ANIM_SUMMON_STAR] = 'peach_summon_star',
        [CHAR_ANIM_SWIM_WITH_OBJ_PART1] = 'peach_swim_with_obj1',
        [CHAR_ANIM_SWIM_WITH_OBJ_PART2] = 'peach_swim_with_obj2',
        [CHAR_ANIM_TRIPLE_JUMP_LAND] = 'peach_triple_jump_land',
        [CHAR_ANIM_TURNING_PART1] = 'peach_turning_part1',
        [CHAR_ANIM_TURNING_PART2] = 'peach_turning_part2',
        [CHAR_ANIM_TWIRL_LAND] = 'peach_twirl_land',
        [CHAR_ANIM_WAKE_FROM_LYING] = 'peach_wake_from_lying',
        [CHAR_ANIM_WAKE_FROM_SLEEP] = 'peach_wake_from_sleep',
        [CHAR_ANIM_CREDITS_RAISE_HAND] = 'peach_credits_raise_hand',
        [CHAR_ANIM_CREDITS_RETURN_FROM_LOOK_UP] = 'peach_credits_return_from_look_up',
        [CHAR_ANIM_CREDITS_START_WALK_LOOK_UP] = 'peach_credits_start_walk_look_up',
        [CHAR_ANIM_CREDITS_TAKE_OFF_CAP] = 'peach_credits_take_off_cap',
        [CHAR_ANIM_DYING_FALL_OVER] = 'peach_dying_fall_over',
        [CHAR_ANIM_FALL_OVER_BACKWARDS] = 'peach_fall_over_backwards',
        [CHAR_ANIM_FAST_LEDGE_GRAB] = 'peach_fast_ledge_grab',
        --[CHAR_ANIM_FINAL_BOWSER_RAISE_HAND_SPIN] = 'peach_final_bowser_raise_hand_spin',
        [CHAR_ANIM_FIRST_PUNCH_FAST] = 'peach_first_punch_fast',
        [CHAR_ANIM_GENERAL_LAND] = 'peach_general_land',
        [CHAR_ANIM_HEAD_STUCK_IN_GROUND] = 'peach_head_stuck_in_ground',
        [CHAR_ANIM_LAND_FROM_DOUBLE_JUMP] = 'peach_land_from_double_jump',
        [CHAR_ANIM_LAND_FROM_SINGLE_JUMP] = 'peach_land_from_single_jump',
        [CHAR_ANIM_LAND_ON_STOMACH] = 'peach_land_on_stomach',
        [CHAR_ANIM_LEGS_STUCK_IN_GROUND] = 'peach_legs_stuck_in_ground',
        [CHAR_ANIM_PLACE_LIGHT_OBJ] = 'peach_place_light_obj',
        [CHAR_ANIM_PUSH_DOOR_WALK_IN] = 'peach_push_door_walk_in',
        [CHAR_ANIM_PUT_CAP_ON] = 'peach_put_cap_on',
        [CHAR_ANIM_RUN_WITH_LIGHT_OBJ] = 'peach_run_with_light_obj',
        [CHAR_ANIM_SECOND_PUNCH_FAST] = 'peach_second_punch_fast',
        [CHAR_ANIM_SHIVERING_RETURN_TO_IDLE] = 'peach_shivering_returning_to_idle',
        [CHAR_ANIM_SKID_ON_GROUND] = 'peach_skid_on_ground',
        [CHAR_ANIM_SLOW_LAND_FROM_DIVE] = 'peach_slow_land_from_dive',
        [CHAR_ANIM_SLOW_LEDGE_GRAB] = 'peach_slow_ledge_grab',
        [CHAR_ANIM_SLOW_WALK_WITH_LIGHT_OBJ] = 'peach_slow_walk_with_light_obj',
        [CHAR_ANIM_STAND_UP_FROM_LAVA_BOOST] = 'peach_stand_up_from_lava_boost',
        [CHAR_ANIM_STOP_SKID] = 'peach_stop_skid',
        [CHAR_ANIM_TAKE_CAP_OFF_THEN_ON] = 'peach_take_cap_off_then_on',
        [CHAR_ANIM_THROW_CATCH_KEY] = 'peach_throw_catch_key',
        [CHAR_ANIM_WALK_WITH_LIGHT_OBJ] = 'peach_walk_with_light_obj',
        [CHAR_ANIM_BOTTOM_STUCK_IN_GROUND] = 'peach_bottom_stuck_in_ground',
        --[CHAR_ANIM_CREDITS_PEACE_SIGN] = 'peach_credits_peace_sign',
        [CHAR_ANIM_FIRE_LAVA_BURN] = 'peach_fire_lava_burn',
        [CHAR_ANIM_GROUND_POUND] = 'peach_ground_pound',
        [CHAR_ANIM_GROUND_POUND_LANDING] = 'peach_ground_pound_landing',
        [CHAR_ANIM_TRIPLE_JUMP_GROUND_POUND] = 'peach_triple_jump_ground_pound_anim',
        [CHAR_ANIM_UNLOCK_DOOR] = 'peach_unlock_door',
        [CHAR_ANIM_SWINGING_BOWSER] = 'peach_swinging_bowser',
        [CHAR_ANIM_HOLDING_BOWSER] = 'peach_holding_bowser',
        [CHAR_ANIM_GRAB_BOWSER] = 'peach_grab_bowser',
        [CHAR_ANIM_BEND_KNESS_RIDING_SHELL] = 'peach_dressfloating',

    }

    
        

    ---@param m MarioState

    function act_dressfloat(m)
        
        -- Apply movement when using action
        common_air_action_step(m, ACT_JUMP_LAND, CHAR_ANIM_BEND_KNESS_RIDING_SHELL, AIR_STEP_NONE)

        -- setup when action starts (horizontal speed and voiceline)
         if m.actionTimer == 0 then
            if m.forwardVel > 20 then
            mario_set_forward_vel(m, 20)
            end
            play_character_sound(m, CHAR_SOUND_HELLO)
         end
        
         -- block all y movement when using the move
         
        m.vel.y = 0
        set_mario_particle_flags(m, PARTICLE_SPARKLES, 0);
        -- avoid issue with flying ? and then make the hover end after 2 secs or when stopping holding the button
        if m.prevAction ~= ACT_TRIPLE_JUMP and MARIO_WING_CAP == true then  
         if m.actionTimer >= 50 or (m.controller.buttonDown & A_BUTTON) == 0 then
            set_mario_action(m, ACT_FREEFALL, 0)
         end
        else
            if m.actionTimer >= 50 or (m.controller.buttonDown & A_BUTTON) == 0 then
                set_mario_action(m, ACT_FREEFALL, 0)
            end
        end
        -- make the action time go forward to yknow, make the hover stop
         m.actionTimer = m.actionTimer + 1
    end

    local function mario_update(m)


        -- check for peach flag; must update animations on every client's end
        if gPlayerSyncTable[m.playerIndex].peachplayer then

        -- Peach floating
        if peachfloat == true then
            if (m.controller.buttonDown & A_BUTTON ) ~= 0 and m.vel.y < -15 then
                if (m.action == ACT_JUMP or m.action == ACT_DOUBLE_JUMP or m.action == ACT_TRIPLE_JUMP or m.action == ACT_LONG_JUMP or m.action == ACT_BACKFLIP or m.action == ACT_SIDE_FLIP or m.action == ACT_WALL_KICK_AIR) then
                   set_mario_action(m, ACT_DRESSFLOAT, 0)
                   peachfloat = false
                   
               end
           end 
       end

--reset the bool to float more than once in a server lol
      if m.action == ACT_JUMP_LAND or m.action == ACT_DOUBLE_JUMP or m.action == ACT_TRIPLE_JUMP_LAND or m.action == ACT_IDLE or m.action == ACT_WALKING then
           peachfloat = true
       end

    end
    if gPlayerSyncTable[m.playerIndex].peachplayer or gPlayerSyncTable[m.playerIndex].peach_nofloat_player then
            local animID = m.marioObj.header.gfx.animInfo.animID

            -- replaced animations
            local luaAnimID = peachplayerAnims[animID]
            if luaAnimID then
                -- if the current anim ID has a valid lua anim ID associated with it, play the custom animation
                smlua_anim_util_set_animation(m.marioObj, luaAnimID)
            end

        end
    end
    hook_mario_action(ACT_DRESSFLOAT,     { every_frame = act_dressfloat })
    hook_event(HOOK_MARIO_UPDATE, mario_update)
    
    hook_event(HOOK_UPDATE, function()
        -- flag to determine if a player is peach (boolean)
        -- this is done in the local update hook because character select can only check for the local player's numbers
        -- gPlayerSyncTable auto syncs the result to all clients
        gPlayerSyncTable[0].peachplayer = (_G.charSelect.character_get_current_number() == CT_PEACH)
        gPlayerSyncTable[0].peach_nofloat_player = (_G.charSelect.character_get_current_number() == CT_PEACH_NOFLOAT)
    end)

else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end
